'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var umiCore = require('@metaplex-foundation/umi-core');
var sha512 = require('@noble/hashes/sha512');

const createDerivedSigner = async (context, originalSigner, message) => {
  const messageBytes = typeof message === 'string' ? umiCore.utf8.serialize(message) : message;
  const signature = await originalSigner.signMessage(messageBytes);
  const seeds = sha512.sha512(signature).slice(0, 32);
  const keypair = context.eddsa.createKeypairFromSeed(seeds);
  return {
    ...umiCore.createSignerFromKeypair(context, keypair),
    originalSigner
  };
};
const isDerivedKeypair = signer => signer.originalSigner !== undefined && umiCore.isKeypairSigner(signer);

exports.createDerivedSigner = createDerivedSigner;
exports.isDerivedKeypair = isDerivedKeypair;
//# sourceMappingURL=DerivedSigner.cjs.map
